import random

def choose(f, b):
	r  = f()
	if b > 0:
		for __ in xrange(b):
			r = max(r, f())
	else:
		for __ in xrange(-b):
			r = min(r, f())
	return r

n = 1000
m = 1000

p = choose(lambda: random.randint(1, 1000000), random.randint(-50, 50))
start = [['X' for __ in xrange(m)] for __ in xrange(n)]
for i in xrange(n):
	for j in xrange(m):
		if random.randint(1, 1000000) >= p:
			start[i][j] = 'X'
		else:
			start[i][j] = 'O'

finish = [start[i][:] for i in xrange(n)]
nmoves = choose(lambda: random.randint(1, 100), random.randint(-40, 10))
for __ in xrange(1000):
	a = random.randint(0, n-1)
	b = random.randint(0, m-1)

	if finish[a][b] == 'O':
		for i in xrange(n): finish[i][b] = 'O'
		for j in xrange(m): finish[a][j] = 'O'
		finish[a][b] = 'X'
		nmoves -= 1
		if nmoves == 0:
			break


count_row = [0 for __ in xrange(n)]
count_col = [0 for __ in xrange(m)]
for i in xrange(n):
	count_row[i] = sum(finish[i][j] == 'X' for j in xrange(m))
for j in xrange(m):
	count_col[j] = sum(finish[i][j] == 'X' for i in xrange(n))

forbidden_rows = set()
forbidden_cols = set()
# if there are two down pegs in a row or column, we can't ever perform move on the rows and cols of those pegs
for i in xrange(n):
	for j in xrange(m):
		if finish[i][j] == 'X' and (count_row[i] >= 2 or count_col[j] >= 2):
			forbidden_rows.add(i)
			forbidden_cols.add(j)

for i in xrange(n):
	for j in xrange(m):
		if i not in forbidden_rows and j not in forbidden_cols:
			start[i][j] = 'X'
			finish[i][j] = 'O'

c = random.randint(0,1)
if c == 1:
	for __ in xrange(20000):
		a = random.randint(0,n-1)
		b = random.randint(0,m-1)
		if (a in forbidden_rows) ^ (b in forbidden_cols) and finish[a][b] == 'X':
			finish[a][b] = 'O'
			break

print n,m
for s in start: print "".join(s)
for s in finish: print "".join(s)